pcl::NormalDistributionsTransform2D< PointSource, PointTarget > Class Template Reference

NormalDistributionsTransform2D provides an implementation of the Normal Distributions Transform algorithm for scan matching. More...

`#include <pcl/registration/ndt_2d.h>`

Inheritance diagram for pcl::NormalDistributionsTransform2D< PointSource, PointTarget >:

## Public Types

using | Ptr = shared_ptr< NormalDistributionsTransform2D< PointSource, PointTarget > >
using | ConstPtr = shared_ptr< const NormalDistributionsTransform2D< PointSource, PointTarget > >
Public Types inherited from pcl::Registration< PointSource, PointTarget, Scalar >
using | Matrix4 = Eigen::Matrix< Scalar, 4, 4 >
using | Ptr = shared_ptr< Registration< PointSource, PointTarget, Scalar > >
using | ConstPtr = shared_ptr< const Registration< PointSource, PointTarget, Scalar > >
using | CorrespondenceRejectorPtr = pcl::registration::CorrespondenceRejector::Ptr
using | KdTree = pcl::search::KdTree< PointTarget >
using | KdTreePtr = typename KdTree::Ptr
using | KdTreeReciprocal = pcl::search::KdTree< PointSource >
using | KdTreeReciprocalPtr = typename KdTreeReciprocal::Ptr
using | PointCloudSource = pcl::PointCloud< PointSource >
using | PointCloudSourcePtr = typename PointCloudSource::Ptr
using | PointCloudSourceConstPtr = typename PointCloudSource::ConstPtr
using | PointCloudTarget = pcl::PointCloud< PointTarget >
using | PointCloudTargetPtr = typename PointCloudTarget::Ptr
using | PointCloudTargetConstPtr = typename PointCloudTarget::ConstPtr
using | PointRepresentationConstPtr = typename KdTree::PointRepresentationConstPtr
using | TransformationEstimation = typename pcl::registration::TransformationEstimation< PointSource, PointTarget, Scalar >
using | TransformationEstimationPtr = typename TransformationEstimation::Ptr
using | TransformationEstimationConstPtr = typename TransformationEstimation::ConstPtr
using | CorrespondenceEstimation = pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, Scalar >
using | CorrespondenceEstimationPtr = typename CorrespondenceEstimation::Ptr
using | CorrespondenceEstimationConstPtr = typename CorrespondenceEstimation::ConstPtr
using | UpdateVisualizerCallbackSignature = void(const pcl::PointCloud< PointSource > &, const pcl::Indices &, const pcl::PointCloud< PointTarget > &, const pcl::Indices &)
| The callback signature to the function updating intermediate source point cloud position during it's registration to the target point cloud. More...
Public Types inherited from pcl::PCLBase< PointSource >
using | PointCloud = pcl::PointCloud< PointSource >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| NormalDistributionsTransform2D ()
| Empty constructor. More...
| ~NormalDistributionsTransform2D ()
| Empty destructor. More...
virtual void | setGridCentre (const Eigen::Vector2f &centre)
| centre of the ndt grid (target coordinate system) More...
virtual void | setGridStep (const Eigen::Vector2f &step)
| Grid spacing (step) of the NDT grid. More...
virtual void | setGridExtent (const Eigen::Vector2f &extent)
| NDT Grid extent (in either direction from the grid centre) More...
virtual void | setOptimizationStepSize (const double &lambda)
| NDT Newton optimisation step size parameter. More...
virtual void | setOptimizationStepSize (const Eigen::Vector3d &lambda)
| NDT Newton optimisation step size parameter. More...
Public Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
| Registration ()
| Empty constructor. More...
| ~Registration ()
| destructor. More...
void | setTransformationEstimation (const TransformationEstimationPtr &te)
| Provide a pointer to the transformation estimation object. More...
void | setCorrespondenceEstimation (const CorrespondenceEstimationPtr &ce)
| Provide a pointer to the correspondence estimation object. More...
virtual void | setInputSource (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target) More...
PointCloudSourceConstPtr const | getInputSource ()
| Get a pointer to the input point cloud dataset target. More...
virtual void | setInputTarget (const PointCloudTargetConstPtr &cloud)
| Provide a pointer to the input target (e.g., the point cloud that we want to align the input source to) More...
PointCloudTargetConstPtr const | getInputTarget ()
| Get a pointer to the input point cloud dataset target. More...
void | setSearchMethodTarget (const KdTreePtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the target cloud. More...
KdTreePtr | getSearchMethodTarget () const
| Get a pointer to the search method used to find correspondences in the target cloud. More...
void | setSearchMethodSource (const KdTreeReciprocalPtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the source cloud (usually used by reciprocal correspondence finding). More...
KdTreeReciprocalPtr | getSearchMethodSource () const
| Get a pointer to the search method used to find correspondences in the source cloud. More...
Matrix4 | getFinalTransformation ()
| Get the final transformation matrix estimated by the registration method. More...
Matrix4 | getLastIncrementalTransformation ()
| Get the last incremental transformation matrix estimated by the registration method. More...
void | setMaximumIterations (int nr_iterations)
| Set the maximum number of iterations the internal optimization should run for. More...
int | getMaximumIterations ()
| Get the maximum number of iterations the internal optimization should run for, as set by the user. More...
void | setRANSACIterations (int ransac_iterations)
| Set the number of iterations RANSAC should run for. More...
double | getRANSACIterations ()
| Get the number of iterations RANSAC should run for, as set by the user. More...
void | setRANSACOutlierRejectionThreshold (double inlier_threshold)
| Set the inlier distance threshold for the internal RANSAC outlier rejection loop. More...
double | getRANSACOutlierRejectionThreshold ()
| Get the inlier distance threshold for the internal outlier rejection loop as set by the user. More...
void | setMaxCorrespondenceDistance (double distance_threshold)
| Set the maximum distance threshold between two correspondent points in source <-> target. More...
double | getMaxCorrespondenceDistance ()
| Get the maximum distance threshold between two correspondent points in source <-> target. More...
void | setTransformationEpsilon (double epsilon)
| Set the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution. More...
double | getTransformationEpsilon ()
| Get the transformation epsilon (maximum allowable translation squared difference between two consecutive transformations) as set by the user. More...
void | setTransformationRotationEpsilon (double epsilon)
| Set the transformation rotation epsilon (maximum allowable rotation difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution. More...
double | getTransformationRotationEpsilon ()
| Get the transformation rotation epsilon (maximum allowable difference between two consecutive transformations) as set by the user (epsilon is the cos(angle) in a axis-angle representation). More...
void | setEuclideanFitnessEpsilon (double epsilon)
| Set the maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged. More...
double | getEuclideanFitnessEpsilon ()
| Get the maximum allowed distance error before the algorithm will be considered to have converged, as set by the user. More...
void | setPointRepresentation (const PointRepresentationConstPtr &point_representation)
| Provide a boost shared pointer to the PointRepresentation to be used when comparing points. More...
bool | registerVisualizationCallback (std::function< UpdateVisualizerCallbackSignature > &visualizerCallback)
| Register the user callback function which will be called from registration thread in order to update point cloud obtained after each iteration. More...
double | getFitnessScore (double max_range=std::numeric_limits< double >::max())
| Obtain the Euclidean fitness score (e.g., mean of squared distances from the source to the target) More...
double | getFitnessScore (const std::vector< float > &distances_a, const std::vector< float > &distances_b)
| Obtain the Euclidean fitness score (e.g., mean of squared distances from the source to the target) from two sets of correspondence distances (distances between source and target points) More...
bool | hasConverged () const
| Return the state of convergence after the last align run. More...
void | align (PointCloudSource &output)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output. More...
void | align (PointCloudSource &output, const Matrix4 &guess)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output. More...
const std::string & | getClassName () const
| Abstract class get name method. More...
bool | initCompute ()
| Internal computation initialization. More...
bool | initComputeReciprocal ()
| Internal computation when reciprocal lookup is needed. More...
void | addCorrespondenceRejector (const CorrespondenceRejectorPtr &rejector)
| Add a new correspondence rejector to the list. More...
std::vector< CorrespondenceRejectorPtr > | getCorrespondenceRejectors ()
| Get the list of correspondence rejectors. More...
bool | removeCorrespondenceRejector (unsigned int i)
| Remove the i-th correspondence rejector in the list. More...
void | clearCorrespondenceRejectors ()
| Clear the list of correspondence rejectors. More...
Public Member Functions inherited from pcl::PCLBase< PointSource >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()=default
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointSource & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeTransformation (PointCloudSource &output, const Eigen::Matrix4f &guess) override
| Rigid transformation computation method with initial guess. More...
Protected Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
bool | searchForNeighbors (const PointCloudSource &cloud, int index, pcl::Indices &indices, std::vector< float > &distances)
| Search for the closest nearest neighbor of a given point. More...
virtual void | computeTransformation (PointCloudSource &output, const Matrix4 &guess)=0
| Abstract transformation computation method with initial guess. More...
Protected Member Functions inherited from pcl::PCLBase< PointSource >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

Eigen::Vector2f | grid_centre_
Eigen::Vector2f | grid_step_
Eigen::Vector2f | grid_extent_
Eigen::Vector3d | newton_lambda_
Protected Attributes inherited from pcl::Registration< PointSource, PointTarget, Scalar >
std::string | reg_name_
| The registration method name. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
KdTreeReciprocalPtr | tree_reciprocal_
| A pointer to the spatial search object of the source. More...
int | nr_iterations_
| The number of iterations the internal optimization ran for (used internally). More...
int | max_iterations_
| The maximum number of iterations the internal optimization should run for. More...
int | ransac_iterations_
| The number of iterations RANSAC should run for. More...
PointCloudTargetConstPtr | target_
| The input point cloud dataset target. More...
Matrix4 | final_transformation_
| The final transformation matrix estimated by the registration method after N iterations. More...
Matrix4 | transformation_
| The transformation matrix estimated by the registration method. More...
Matrix4 | previous_transformation_
| The previous transformation matrix estimated by the registration method (used internally). More...
double | transformation_epsilon_
| The maximum difference between two consecutive transformations in order to consider convergence (user defined). More...
double | transformation_rotation_epsilon_
| The maximum rotation difference between two consecutive transformations in order to consider convergence (user defined). More...
double | euclidean_fitness_epsilon_
| The maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged. More...
double | corr_dist_threshold_
| The maximum distance threshold between two correspondent points in source <-> target. More...
double | inlier_threshold_
| The inlier distance threshold for the internal RANSAC outlier rejection loop. More...
bool | converged_
| Holds internal convergence state, given user parameters. More...
int | min_number_correspondences_
| The minimum number of correspondences that the algorithm needs before attempting to estimate the transformation. More...
CorrespondencesPtr | correspondences_
| The set of correspondences determined at this ICP step. More...
TransformationEstimationPtr | transformation_estimation_
| A TransformationEstimation object, used to calculate the 4x4 rigid transformation. More...
CorrespondenceEstimationPtr | correspondence_estimation_
| A CorrespondenceEstimation object, used to estimate correspondences between the source and the target cloud. More...
std::vector< CorrespondenceRejectorPtr > | correspondence_rejectors_
| The list of correspondence rejectors to use. More...
bool | target_cloud_updated_
| Variable that stores whether we have a new target cloud, meaning we need to pre-process it again. More...
bool | source_cloud_updated_
| Variable that stores whether we have a new source cloud, meaning we need to pre-process it again. More...
bool | force_no_recompute_
| A flag which, if set, means the tree operating on the target cloud will never be recomputed. More...
bool | force_no_recompute_reciprocal_
| A flag which, if set, means the tree operating on the source cloud will never be recomputed. More...
std::function< UpdateVisualizerCallbackSignature > | update_visualizer_
| Callback function to update intermediate source point cloud position during it's registration to the target point cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointSource >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointSource, typename PointTarget>
class pcl::NormalDistributionsTransform2D< PointSource, PointTarget >

NormalDistributionsTransform2D provides an implementation of the Normal Distributions Transform algorithm for scan matching.

This implementation is intended to match the definition: Peter Biber and Wolfgang Straßer. The normal distributions transform: A new approach to laser scan matching. In Proceedings of the IEEE In- ternational Conference on Intelligent Robots and Systems (IROS), pages 2743–2748, Las Vegas, USA, October 2003.

Author
  James Crosby

Definition at line 59 of file ndt_2d.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointSource , typename PointTarget >

using pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::ConstPtr = shared_ptr<const NormalDistributionsTransform2D<PointSource, PointTarget> >

Definition at line 73 of file ndt_2d.h.

## Ptr

template<typename PointSource , typename PointTarget >

using pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::Ptr = shared_ptr<NormalDistributionsTransform2D<PointSource, PointTarget> >

Definition at line 72 of file ndt_2d.h.

## Constructor & Destructor Documentation

## NormalDistributionsTransform2D()

template<typename PointSource , typename PointTarget >

pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::NormalDistributionsTransform2D | ( |  | ) |

inline

Empty constructor.

Definition at line 77 of file ndt_2d.h.

References pcl::Registration< PointSource, PointTarget, Scalar >::reg_name_.

## ~NormalDistributionsTransform2D()

template<typename PointSource , typename PointTarget >

pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::~NormalDistributionsTransform2D | ( |  | ) |

inline

Empty destructor.

Definition at line 88 of file ndt_2d.h.

## Member Function Documentation

## computeTransformation()

template<typename PointSource , typename PointTarget >

void pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::computeTransformation | ( | PointCloudSource & | output,
|  | const Eigen::Matrix4f & | guess
| ) |  |

override protected

Rigid transformation computation method with initial guess.

Parameters

  [out] | output | the transformed input point cloud dataset using the rigid transformation found
  [in] | guess | the initial guess of the transformation to compute

Definition at line 389 of file ndt_2d.hpp.

References pcl::ndt2d::ValueAndDerivatives< N, T >::grad, pcl::ndt2d::ValueAndDerivatives< N, T >::hessian, pcl::ndt2d::NDT2D< PointT >::test(), pcl::transformPointCloud(), pcl::ndt2d::ValueAndDerivatives< N, T >::value, and pcl::ndt2d::ValueAndDerivatives< N, T >::Zero().

## setGridCentre()

template<typename PointSource , typename PointTarget >

virtual void pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::setGridCentre | ( | const Eigen::Vector2f & | centre | ) |

inline virtual

centre of the ndt grid (target coordinate system)

Parameters

  centre | value to set

Definition at line 94 of file ndt_2d.h.

References pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::grid_centre_.

## setGridExtent()

template<typename PointSource , typename PointTarget >

virtual void pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::setGridExtent | ( | const Eigen::Vector2f & | extent | ) |

inline virtual

NDT Grid extent (in either direction from the grid centre)

Parameters

  [in] | extent | value to set

Definition at line 112 of file ndt_2d.h.

References pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::grid_extent_.

## setGridStep()

template<typename PointSource , typename PointTarget >

virtual void pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::setGridStep | ( | const Eigen::Vector2f & | step | ) |

inline virtual

Grid spacing (step) of the NDT grid.

Parameters

  [in] | step | value to set

Definition at line 103 of file ndt_2d.h.

References pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::grid_step_.

## setOptimizationStepSize() [1/2]

template<typename PointSource , typename PointTarget >

virtual void pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::setOptimizationStepSize | ( | const double & | lambda | ) |

inline virtual

NDT Newton optimisation step size parameter.

Parameters

  [in] | lambda | step size: 1 is simple newton optimisation, smaller values may improve convergence

Definition at line 122 of file ndt_2d.h.

References pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::newton_lambda_.

## setOptimizationStepSize() [2/2]

template<typename PointSource , typename PointTarget >

virtual void pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::setOptimizationStepSize | ( | const Eigen::Vector3d & | lambda | ) |

inline virtual

NDT Newton optimisation step size parameter.

Parameters

  [in] | lambda | step size: (1,1,1) is simple newton optimisation, smaller values may improve convergence, or elements may be set to zero to prevent optimisation over some parameters

This overload allows control of updates to the individual (x, y, theta) free parameters in the optimisation. If, for example, theta is believed to be close to the correct value a small value of lambda[2] should be used.

Definition at line 138 of file ndt_2d.h.

References pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::newton_lambda_.

## Member Data Documentation

## grid_centre_

template<typename PointSource , typename PointTarget >

Eigen::Vector2f pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::grid_centre_

protected

Definition at line 166 of file ndt_2d.h.

Referenced by pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::setGridCentre().

## grid_extent_

template<typename PointSource , typename PointTarget >

Eigen::Vector2f pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::grid_extent_

protected

Definition at line 168 of file ndt_2d.h.

Referenced by pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::setGridExtent().

## grid_step_

template<typename PointSource , typename PointTarget >

Eigen::Vector2f pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::grid_step_

protected

Definition at line 167 of file ndt_2d.h.

Referenced by pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::setGridStep().

## newton_lambda_

template<typename PointSource , typename PointTarget >

Eigen::Vector3d pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::newton_lambda_

protected

Definition at line 169 of file ndt_2d.h.

Referenced by pcl::NormalDistributionsTransform2D< PointSource, PointTarget >::setOptimizationStepSize().

The documentation for this class was generated from the following files:

- pcl/registration/ndt_2d.h
- pcl/registration/impl/ndt_2d.hpp